# Copyright (C) 2010-2011 Richard Lincoln
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

"""This package contains the information classes that support distribution management in general.
"""

from CIM14.IEC61968.Common.Organisation import Organisation
from CIM14.IEC61968.Common.Status import Status
from CIM14.IEC61968.Common.Document import Document
from CIM14.IEC61968.Common.TimeSchedule import TimeSchedule
from CIM14.IEC61968.Common.TownDetail import TownDetail
from CIM14.IEC61968.Common.Location import Location
from CIM14.IEC61968.Common.PostalAddress import PostalAddress
from CIM14.IEC61968.Common.PositionPoint import PositionPoint
from CIM14.IEC61968.Common.ActivityRecord import ActivityRecord
from CIM14.IEC61968.Common.StreetAddress import StreetAddress
from CIM14.IEC61968.Common.TimePoint import TimePoint
from CIM14.IEC61968.Common.Agreement import Agreement
from CIM14.IEC61968.Common.DateTimeInterval import DateTimeInterval
from CIM14.IEC61968.Common.StreetDetail import StreetDetail
from CIM14.IEC61968.Common.ElectronicAddress import ElectronicAddress
from CIM14.IEC61968.Common.TelephoneNumber import TelephoneNumber
from CIM14.IEC61968.Common.UserAttribute import UserAttribute
from CIM14.IEC61968.Common.CoordinateSystem import CoordinateSystem

nsURI = "http://iec.ch/TC57/2009/CIM-schema-cim14#Common"
nsPrefix = "cimCommon"

